dim taste$
dim temp as int

const stack = 0x0100
dim speicher[65536]

dim pc as uint
dim rega as uint
dim regx as uint
dim regy as uint

dim flags as uint

dim cyclecount as long
dim runstate as char
dim stackpointer as int

dim raw fp1 as FILE
' Wir fangen hier an...

stackpointer = stack + 0xff

for temp = 0x000 to 0xffff
  speicher[temp] = 0x00
next temp

' Kernel laden
open "kernal" for binary as fp1

for temp = 0xe000 to 0xffff
  !fread(&speicher[temp],1,1,fp1);
next temp

close fp1

open "pc.log" for output as fp1

pc = speicher[0xfffc]+(speicher[0xfffd]*256)
fprint fp1, hex$(pc)
print "Stack startet bei = ",stack
print "LoByte Speicher = ",speicher[0xfffe]
print "HiByte Speicher = ",speicher[0xffff]
print "PC = ", pc



do
  print " "
  print "6502BCX"
  print "-------"
  print "r = Laufen bis BRK"
  print "x = Beenden"
  input ">",taste$

  if taste$="r" then emulate()
  if taste$="x" then
    close fp1
    end
  endif
loop



sub emulate()
  cls
  runstate = 1
  while runstate
    fprint fp1, hex$(pc),bin$(flags)
    cls
    print "PC = ",hex$(pc)
    print "Speicherausschnitt = ",",",hex$(speicher[pc-3]),",",hex$(speicher[pc-2]),",",hex$(speicher[pc-1]),"[",hex$(speicher[pc]),"]",hex$(speicher[pc+1]),",",hex$(speicher[pc+2]),",",hex$(speicher[pc+3])
    print "A = ",hex$(rega)," X = ",hex$(regx)," Y = ",hex$(regy)
    print "FLAGS = ", bin$(flags)
    print " "
    'pause
    select case speicher[pc]
      case 0x00 ' BRK - Zur Zeit beendet es den Emulator ;)
        runstate = 0
        pc+=2
        cyclecount+=7

      ' Ladebefehle Akkumulator
      case 0xa9 ' LDA Direkt
        rega=lade_direkt()
        negativ_reg(rega)
        null_reg(rega)
        cyclecount+=2
        pc+=2
      case 0xa5 ' LDA Zeropage
        rega=lade_absolut_zeropage()
        negativ_reg(rega)
        null_reg(rega)
        cyclecount+=3
        pc+=2
      case 0xb5 ' LDA Zeropage,X
        rega=lade_absolut_zeropage_x()
        negativ_reg(rega)
        null_reg(rega)
        cyclecount+=4
        pc+=2
      case 0xad ' LDA Absolut
        rega=lade_absolut()
        negativ_reg(rega)
        null_reg(rega)
        cyclecount+=4
        pc+=3
      case 0xbd ' LDA Absolut mit X
        rega = lade_absolut_x()
        negativ_reg(rega)
        null_reg(rega)
        cyclecount+=4
        pc+=3
      case 0xb9 ' LDA Absolut mit Y
        rega = lade_absolut_y()
        negativ_reg(rega)
        null_reg(rega)
        cyclecount+=4
        pc+=3
      case 0xa1 ' LDA Indirekt mit X
        rega = lade_indirekt_x()
        negativ_reg(rega)
        null_reg(rega)
        cyclecount+=6
        pc+=2
      case 0xb1 ' LDA Indirekt mit Y
        rega = lade_indirekt_y()
        negativ_reg(rega)
        null_reg(rega)
        cyclecount+=5
        pc+=2

      ' Ladebefehle X-Register
      case 0xa2 ' LDX Direkt
        regx=lade_direkt()
        negativ_reg(regx)
        null_reg(regx)
        cyclecount+=2
        pc+=2
      case 0xa6 ' LDX Zeropage
        rega=lade_absolut_zeropage()
        negativ_reg(regx)
        null_reg(regx)
        cyclecount+=3
        pc+=2
      case 0xb6 ' LDX Zeropage,Y
        rega=lade_absolut_zeropage_y()
        negativ_reg(regx)
        null_reg(regx)
        cyclecount+=4
        pc+=2
      case 0xae ' LDX Absolut
        rega=lade_absolut()
        negativ_reg(regx)
        null_reg(regx)
        cyclecount+=4
        pc+=3
      case 0xbe ' LDX Absolut mit Y
        rega = lade_absolut_y()
        negativ_reg(regx)
        null_reg(regx)
        cyclecount+=4
        pc+=3

      'Ladebefehle Y-Register
      case 0xa0 ' LDY Direkt
        regy=lade_direkt()
        negativ_reg(regy)
        null_reg(regy)
        cyclecount+=2
        pc+=2
      case 0xa4 ' LDY Zeropage
        rega=lade_absolut_zeropage()
        negativ_reg(regy)
        null_reg(regy)
        cyclecount+=3
        pc+=2
      case 0xb4 ' LDY Zeropage,X
        rega=lade_absolut_zeropage_x()
        negativ_reg(regy)
        null_reg(regy)
        cyclecount+=4
        pc+=2
      case 0xac ' LDY Absolut
        rega=lade_absolut()
        negativ_reg(regy)
        null_reg(regy)
        cyclecount+=4
        pc+=3
      case 0xbc ' LDY Absolut mit X
        rega = lade_absolut_x()
        negativ_reg(regy)
        null_reg(regy)
        cyclecount+=4
        pc+=3

      ' Logisches AND mit Akkumulator
      case 0x29 ' AND Direkt
        rega = rega & lade_direkt()
        negativ_reg(rega)
        null_reg(rega)
        cyclecount+=2
        pc+=2
      case 0x25 ' AND Zeropage
        rega = rega & lade_absolut_zeropage()
        negativ_reg(rega)
        null_reg(rega)
        cyclecount+=2
        pc+=2
      case 0x35 ' AND Zeropage mit X
        rega = rega & lade_absolut_zeropage_x()
        negativ_reg(rega)
        null_reg(rega)
        cyclecount+=3
        pc+=2
      case 0x2d ' AND Direkt
        rega = rega & lade_absolut()
        negativ_reg(rega)
        null_reg(rega)
        cyclecount+=4
        pc+=3
      case 0x3d ' AND direkt mit x
        rega = rega & lade_absolut_x()
        negativ_reg(rega)
        null_reg(rega)
        cyclecount+=4
        pc+=3
      case 0x39 ' AND direkt mit y
        rega = rega & lade_absolut_y()
        negativ_reg(rega)
        null_reg(rega)
        cyclecount+=4
        pc+=3
      case 0x21 ' AND indirekt mit x
        rega = rega & lade_indirekt_x()
        negativ_reg(rega)
        null_reg(rega)
        cyclecount+=6
        pc+=2
      case 0x31 ' AND indirekt mit y
        rega = rega & lade_indirekt_y()
        negativ_reg(rega)
        null_reg(rega)
        cyclecount+=5
        pc+=2



      ' Logisches OR mit Akkumulator
      case 0x09 ' ORA Direkt
        rega = rega bor lade_direkt()
        negativ_reg(rega)
        null_reg(rega)
        cyclecount+=2
        pc+=2
      case 0x05 ' ORA Zeropage
        rega = rega bor lade_absolut_zeropage()
        negativ_reg(rega)
        null_reg(rega)
        cyclecount+=2
        pc+=2
      case 0x15 ' ORA Zeropage mit X
        rega = rega bor lade_absolut_zeropage_x()
        negativ_reg(rega)
        null_reg(rega)
        cyclecount+=3
        pc+=2
      case 0x0d ' ORA Direkt
        rega = rega bor lade_absolut()
        negativ_reg(rega)
        null_reg(rega)
        cyclecount+=4
        pc+=3
      case 0x1d ' ORA direkt mit x
        rega = rega bor lade_absolut_x()
        negativ_reg(rega)
        null_reg(rega)
        cyclecount+=4
        pc+=3
      case 0x19 ' ORA direkt mit y
        rega = rega bor lade_absolut_y()
        negativ_reg(rega)
        null_reg(rega)
        cyclecount+=4
        pc+=3
      case 0x01 ' ORA indirekt mit x
        rega = rega bor lade_indirekt_x()
        negativ_reg(rega)
        null_reg(rega)
        cyclecount+=6
        pc+=2
      case 0x11 ' ORA indirekt mit y
        rega = rega bor lade_indirekt_y()
        negativ_reg(rega)
        null_reg(rega)
        cyclecount+=5
        pc+=2



      case 0x20 ' JSR Direkt
        ' Stack mit altem PC + 2 fllen
        temp = pc + 2
        speicher[stackpointer] = temp / 256
        stackpointer--
        speicher[stackpointer] = temp & 0xff
        stackpointer--
        ' Flags kommen mit auf den Stack
        'speicher[stackpointer] = flags
        'stackpointer--

        'PC neu fllen
        temp = speicher[pc+1]+(speicher[pc+2]*256)
        pc = temp
        cyclecount+=6

      case 0x60 ' RTS Rcksprung
        ' Flags vom Stack holen
        'flags = speicher[stackpointer]
        'stackpointer++
        ' PC vom Stack holen
        pc = speicher[stackpointer+1]+(speicher[stackpointer+2]*256)
        pc++
        stackpointer+=2
        cyclecount+=6

      'Unbedingte Sprungbefehle
      case 0x4c ' JMP Direkt
        pc = speicher[pc+1]+(speicher[pc+2]*256)
        cyclecount+=3
      case 0x6c ' JMP Indirekt
        pc = speicher[speicher[pc+1]]+(speicher[speicher[pc+2]]*256)
        cyclecount+=3

      case 0x48 ' PHA Akku in Stack
        speicher[stackpointer] = rega
        stackpointer--
        cyclecount+=3
        pc++

      ' Flags bearbeiten
      case 0x18 ' CLC bertrag lschen
        flags = flags and 0xfe
        cyclecount+=2
        pc++
      case 0x38 ' SEC bertrag setzen
        flags = flags or 0x01
        cyclecount+=2
        pc++
      case 0x58 ' CLI Interrupt Flag setzen
        flags = flags and 0xfb
        cyclecount+=2
        pc++
      case 0x78 ' SEI Interrupt Flag setzen
        flags = flags or 0x04
        cyclecount+=2
        pc++
      case 0xb8 ' CLV berlauf lschen
        flags = flags and 0xbf
        cyclecount+=2
        pc++
      case 0xd8 ' CLD Dezimal lschen
        flags = flags and 0xf7
        cyclecount+=2
        pc++
      case 0xf8 ' SED Dezimal setzen
        flags = flags or 0x08
        cyclecount+=2
        pc++

      'Speicherbefehle
      case 0x85 ' STA Zeropage
        speicher_absolut_zeropage(rega)
        pc+=2
        cyclecount+=3
      case 0x95 ' STA Zeropage,x
        speicher_absolut_zeropage_x(rega)
        pc+=2
        cyclecount+=4
      case 0x8d ' STA Absolut
        speicher_absolut(rega)
        pc+=3
        cyclecount+=4
      case 0x9d ' STA Absolut,X
        speicher_absolut_x(rega)
        pc+=3
        cyclecount+=5
      case 0x99 ' STA Absolut,Y
        speicher_absolut_y(rega)
        pc+=3
        cyclecount+=5
      case 0x81 ' STA Indirekt,X
        speicher_indirekt_x(rega)
        pc+=2
        cyclecount+=6
      case 0x91 ' STA Indirekt,Y
        speicher_indirekt_y(rega)
        pc+=2
        cyclecount+=6

      case 0x86 ' STX Zeropage
        speicher_absolut_zeropage(regx)
        pc+=2
        cyclecount+=3
      case 0x96 ' STX Zeropage,y
        speicher_absolut_zeropage_y(regx)
        pc+=2
        cyclecount+=4
      case 0x8e ' STX Absolut
        speicher_absolut(regx)
        pc+=3
        cyclecount+=4


      case 0x84 ' STY Zeropage
        speicher_absolut_zeropage(regy)
        pc+=2
        cyclecount+=3
      case 0x94 ' STY Zeropage,y
        speicher_absolut_zeropage_x(regy)
        pc+=2
        cyclecount+=4
      case 0x8c ' STY Absolut
        speicher_absolut(regy)
        pc+=3
        cyclecount+=4



      'Rechts rotieren
      case 0x2a ' ROL mit Akku
        rega = rega * 2
        if rega > 0xff then
          rega = rega & 0xff
          flags = flags and 0xfe
        else
          flags = flags or 0x1
        endif
        negativ_reg(rega)
        null_reg(rega)
        pc++
        cyclecount+=2
      case 0x26 ' ROL mit Zeropage
        temp = lade_absolut_zeropage()
        temp = temp * 2
        if temp > 0xff then
          temp = temp & 0xff
          flags = flags and 0xfe
        else
          flags = flags or 0x1
        endif
        negativ_reg(temp)
        null_reg(temp)
        speicher_absolut_zeropage(temp)
        pc+=2
        cyclecount+=2
      case 0x36 ' ROL mit Zeropage und X
        temp = lade_absolut_zeropage_x()
        temp = temp * 2
        if temp > 0xff then
          temp = temp & 0xff
          flags = flags and 0xfe
        else
          flags = flags or 0x1
        endif
        negativ_reg(temp)
        null_reg(temp)
        speicher_absolut_zeropage_x(temp)
        pc+=2
        cyclecount+=2
      case 0x2e ' ROL Absolut
        temp = lade_absolut()
        temp = temp * 2
        if temp > 0xff then
          temp = temp & 0xff
          flags = flags and 0xfe
        else
          flags = flags or 0x1
        endif
        negativ_reg(temp)
        null_reg(temp)
        speicher_absolut(temp)
        pc+=2
        cyclecount+=2
      case 0x3e ' ROL Absolut und X
        temp = lade_absolut_x()
        temp = temp * 2
        if temp > 0xff then
          temp = temp & 0xff
          flags = flags and 0xfe
        else
          flags = flags or 0x1
        endif
        negativ_reg(temp)
        null_reg(temp)
        speicher_absolut_x(temp)
        pc+=2
        cyclecount+=2

      'Um eins Addieren
      case 0xe6 ' INC SP + 1 Zeropage
        temp = lade_absolut_zeropage()
        if temp = 0xff then
          temp = 0x0
        else
          temp++
        endif
        negativ_reg(temp)
        null_reg(temp)
        speicher_absolut_zeropage(temp)
        pc+=2
        cyclecount+=5
      case 0xf6 ' INC SP + 1 Zeropage mit X
        temp = lade_absolut_zeropage_x()
        if temp = 0xff then
          temp = 0x0
        else
          temp++
        endif
        negativ_reg(temp)
        null_reg(temp)
        speicher_absolut_zeropage_x(temp)
        pc+=2
        cyclecount+=5
      case 0xee ' INC SP + 1 Absolut
        temp = lade_absolut()
        if temp = 0xff then
          temp = 0x0
        else
          temp++
        endif
        negativ_reg(temp)
        null_reg(temp)
        speicher_absolut(temp)
        pc+=3
        cyclecount+=6
      case 0xfe ' INC SP + 1 Absolut mit X
        temp = lade_absolut_x()
        if temp = 0xff then
          temp = 0x0
        else
          temp++
        endif
        negativ_reg(temp)
        null_reg(temp)
        speicher_absolut_x(temp)
        pc+=3
        cyclecount+=7

      case 0x88 ' DEY Y - 1
        if regy = 0 then
          regy = 0xff
        else
          regy--
        endif
        negativ_reg(regy)
        null_reg(regy)
        pc++
        cyclecount+=2
      case 0xc8 ' INY Y + 1
        if regy = 0xff then
          regy = 0x0
        else
          regy++
        endif
        negativ_reg(regy)
        null_reg(regy)
        pc++
        cyclecount+=2

      case 0xca ' DEX X - 1
        if regx = 0 then
          regx = 0xff
        else
          regx--
        endif
        negativ_reg(regx)
        null_reg(regx)
        pc++
        cyclecount+=2
      case 0xea ' INX X + 1
        if regx = 0xff then
          regx = 0x0
        else
          regx++
        endif
        negativ_reg(regx)
        null_reg(regx)
        pc++
        cyclecount+=2

      ' Transferbefehle
      case 0xaa ' TAX Akku ins X
        regx = rega
        negativ_reg(regx)
        null_reg(regx)
        pc++
        cyclecount+=2
      case 0x8a ' TXA X ins Akku
        rega = regx
        negativ_reg(rega)
        null_reg(rega)
        pc++
        cyclecount+=2
      case 0xa8 ' TAY Akku ins Y
        regy = rega
        negativ_reg(regy)
        null_reg(regy)
        pc++
        cyclecount+=2
      case 0x98 ' TYA Y ins Akku
        rega = regy
        negativ_reg(rega)
        null_reg(rega)
        pc++
        cyclecount+=2
      case 0xba 'TSX Stackpointer ins X
        regx = stackpointer - 0x100
        negativ_reg(regx)
        null_reg(regx)
        pc++
        cyclecount+=2
      case 0x9a 'TXS X zu Stackpointer
        stackpointer = regx + 0x100
        negativ_reg(regx) 'Im Stack ist ja das selbe wie im X
        null_reg(regx)    'also kann man das so lassen
        pc++
        cyclecount+=2

      'Vergleichsbefehle
      case 0xc9 ' CMP Vergleicht 2 Werte, direkt
        temp = lade_direkt()
        cmp_flagssetzen()
        pc+=2
        cyclecount+=2
      case 0xc5 ' CMP Vergleicht 2 Werte, Zeropage
        temp = lade_absolut_zeropage()
        cmp_flagssetzen()
        pc+=2
        cyclecount+=3
      case 0xd5 ' CMP Vergleicht 2 Werte, Zeropage mit X
        temp = lade_absolut_zeropage_x()
        cmp_flagssetzen()
        pc+=2
        cyclecount+=4
      case 0xcd ' CMP Vergleicht 2 Werte, Absolut
        temp = lade_absolut()
        cmp_flagssetzen()
        pc+=3
        cyclecount+=4
      case 0xdd ' CMP Vergleicht 2 Werte, Absolut mit X
        temp = lade_absolut_x()
        cmp_flagssetzen()
        pc+=3
        cyclecount+=4
      case 0xd9 ' CMP Vergleicht 2 Werte, Absolut mit Y
        temp = lade_absolut_y()
        cmp_flagssetzen()
        pc+=3
        cyclecount+=4
      case 0xc1 ' CMP Vergleicht 2 Werte, Indirekt mit X
        temp = lade_indirekt_x()
        cmp_flagssetzen()
        pc+=2
        cyclecount+=6
      case 0xd1 ' CMP Vergleicht 2 Werte, Indirekt mit Y
        temp = lade_indirekt_y()
        cmp_flagssetzen()
        pc+=2
        cyclecount+=5

      'Bedingte Sprungbefehle
      case 0x10 ' BPL Sprung wenn NegativFlag = 0
        if not flags & 0x80 then
          branch_ausfuehren()
        else
          pc+=2
        endif
        cyclecount+=3

      case 0x30 ' BMI Sprung wenn NegativFlag = 1
        if flags & 0x80 then
          branch_ausfuehren()
        else
          pc+=2
        endif
        cyclecount+=3

      case 0x50 ' BVC Sprung wenn berlaufFlag = 0
        if not flags & 0x40 then
          branch_ausfuehren()
        else
          pc+=2
        endif
        cyclecount+=3

      case 0x70 ' BVS Sprung wenn berlaufFlag = 1
        if flags & 0x40 then
          branch_ausfuehren()
        else
          pc+=2
        endif
        cyclecount+=3

      case 0x90 ' BCC Sprung wenn bertragFlag = 0
        if not flags & 0x1 then
          branch_ausfuehren()
        else
          pc+=2
        endif
        cyclecount+=3

      case 0xb0 ' BCS Sprung wenn bertragFlag = 1
        if flags & 0x1 then
          branch_ausfuehren()
        else
          pc+=2
        endif
        cyclecount+=3

      case 0xd0 ' BNE Sprung wenn NullFlag = 0
        if flags & 0x2 then
          branch_ausfuehren()
        else
          pc+=2
        endif
        cyclecount+=3

      case 0xf0 ' BEQ Sprung wenn NullFlag = 1
        if not flags & 0x2 then
          branch_ausfuehren()
        else
          pc+=2
        endif
        cyclecount+=3

      case else
        pc++
        print "Unbekannter Opcode!"
        runstate = 0
    end select

  wend

end sub

sub branch_ausfuehren()
  if speicher[pc+1] & 0x80 then
    pc = pc - lade_direkt()
  else
    pc = pc + lade_direkt() + 2
  endif
end sub

sub cmp_flagssetzen()
  'Negativ?
  if temp & 0x80 then
    flags = flags or 0x80
  else
    flags = flags and 0x7f
  endif
  'Nullflag?
  if temp = rega then
    flags = flags and 0xfd
  else
    flags = flags or 0x2
  endif
 'Carryflag?
  if temp < rega then
    flags = flags and 0xfe
  else
    flags = flags or 0x1
  endif
end sub

' Flags prfen fr Register A
sub negativ_reg(testreg as uint)
  ' Negativ Flag?
  if testreg & 0x80 then
    flags = flags or 0x80
  else
    flags = flags and 0x7f
  endif
end sub

sub null_reg(testreg as uint)
  ' Null Flag?
  if testreg then
    flags = flags and 0xfd
  else
    flags = flags or 0x2
  endif
end sub


' Alle Laderoutinen
function lade_direkt()
' Direkt laden was hinter dem Befehl steht
function = speicher[pc+1]
end function

function lade_absolut_zeropage()
' Laden was in der ZP an der Stelle PC+1 steht
function = speicher[speicher[pc+1]]
end function

function lade_absolut_zeropage_x()
' Laden was in der ZP+X an der Stelle PC+1 steht
' TODO: X = 0xFF, und dann? ;)
function = speicher[speicher[pc+1]+regx]
end function

function lade_absolut_zeropage_y()
' Laden was in der ZP+Y an der Stelle PC+1 steht
' TODO: Y = 0xFF, und dann? ;)
function = speicher[speicher[pc+1]+regy]
end function

function lade_absolut()
' Laden was an der Stelle PC+1(LoByte) PC+2(HighByte) steht
function = speicher[speicher[pc+1]+(speicher[pc+2]*256)]
end function

function lade_absolut_x()
' Laden was an der Stelle PC+1(LoByte) PC+2(HighByte) + regx steht
function = speicher[(speicher[pc+1]+(speicher[pc+2]*256))+regx]
end function

function lade_absolut_y()
' Laden was an der Stelle PC+1(LoByte) PC+2(HighByte) + regy steht
function = speicher[(speicher[pc+1]+(speicher[pc+2]*256))+regy]
end function

function lade_indirekt_x()
' Indirekt Indiziert ;)
function = speicher[(speicher[speicher[pc]+1+regx]+(speicher[speicher[pc]+2+regx]*256))+regx]
end function

function lade_indirekt_y()
' Indirekt Indiziert ;)
function = speicher[(speicher[speicher[pc]+1]+(speicher[speicher[pc]+2]*256))+regy]
end function

'Speicherroutinen
sub speicher_absolut_zeropage(spreg as int)
' Laden was in der ZP an der Stelle PC+1 steht
speicher[speicher[pc+1]] = spreg
end sub

sub speicher_absolut_zeropage_x(spreg as int)
' Laden was in der ZP+X an der Stelle PC+1 steht
' TODO: X = 0xFF, und dann? ;)
speicher[speicher[pc+1]+regx] = spreg
end sub

sub speicher_absolut_zeropage_y(spreg as int)
' Laden was in der ZP+Y an der Stelle PC+1 steht
' TODO: Y = 0xFF, und dann? ;)
speicher[speicher[pc+1]+regy] = spreg
end sub

sub speicher_absolut(spreg as int)
' Laden was an der Stelle PC+1(LoByte) PC+2(HighByte) steht
speicher[speicher[pc+1]+(speicher[pc+2]*256)] = spreg
end sub

sub speicher_absolut_x(spreg as int)
' Laden was an der Stelle PC+1(LoByte) PC+2(HighByte) + regx steht
speicher[(speicher[pc+1]+(speicher[pc+2]*256))+regx] = spreg
end sub

sub speicher_absolut_y(spreg as int)
' Laden was an der Stelle PC+1(LoByte) PC+2(HighByte) + regy steht
speicher[(speicher[pc+1]+(speicher[pc+2]*256))+regy] = spreg
end sub

sub speicher_indirekt_x(spreg as int)
' Indirekt Indiziert ;)
speicher[(speicher[speicher[pc]+1+regx]+(speicher[speicher[pc]+2+regx]*256))+regx] = spreg
end sub

sub speicher_indirekt_y(spreg as int)
' Indirekt Indiziert ;)
speicher[(speicher[speicher[pc]+1]+(speicher[speicher[pc]+2]*256))+regy] = spreg
end sub

